$(document).ready(function() {
//	function basename(str) {
//	   var base = new String(str).substring(str.lastIndexOf('/') + 1); 
//	    if(base.lastIndexOf(".") != -1)       
//	       base = base.substring(0, base.lastIndexOf("."));
//	   return base;
//	}
//	
	function doReset() {
		$('#processing').hide();
		$('#uploading').hide();
		$('#restore').hide();
		$('#upload').show();
		$('#restored').hide();
		$('#restoreapps').empty();
		$('#restoring').hide();
	}

	function doError() {
		doReset();
		$('#error').show();
	}
	
	function doRestore() {
		doReset();
		$('#processing').hide();
		$('#uploading').hide();
		$('#upload').hide();
		$('#error').hide();
		$('#restore').show();
	}
	
	$('#cancel-restore').click(doReset);

	$('#do-restore').click(function() {
		$('#processing').hide();
		$('#uploading').hide();
		$('#upload').hide();
		$('#error').hide();
		$('#restore').hide();
		$('#restoring').show();
		$.get('/api/restore', function() {
			doReset();
			$('#restored').show();
			setTimeout(refreshApps, 5000);
		});
	});
	
	$('#fileupload').fileupload({
		dataType: 'json',
		add: function (e, data) {
			$('#uploading').show();
			$('#upload').hide();
			data.submit();
        },
        done: function(e, data) {
			$('#uploading').hide();
			$('#processing').show();
			$.ajax({
				url: '/api/restore.zip/backup.json',
				success: function(data) {
					$.get('/views/restoreapp.jade', function(appTemplate) {
						var row;
						$.each(data.packages, function(index, app) {
							if (row == null || row[0].children.length == 4) {
								if (row != null) {
									$('#restoreapps').append(row);
								}
								row = $('<div class="row"></div>')
							}
							app.icon = '/api/restore.zip/' + app.packageName + '.png';
							
							jade.render(appTemplate, {
								app: app
							}, function(err, data) {
								if (err) {
									console.log(err);
									return;
								}

								row.append($(data));
							});
						});
						
						if (row != null) {
							var prepend = 12 - $(row).find('.restoreapp').length * 3;
							if (prepend != 0) {
								prepend = Math.round(prepend / 2);
								$(row).prepend('<div class="span' + prepend + '"></div>');
							}
							$('#restoreapps').append(row);
						}
					});

					doRestore();
				},
				error: function(e) {
		        	doError();
				}
			});
        },
        fail: function(e, data) {
        	doError();
        },
	    dropZone: $('#dropzone')
	});
	$(document).bind('dragover', function (e) {
	    var dropZone = $('#dropzone'),
	        timeout = window.dropZoneTimeout;
	    if (!timeout) {
	        dropZone.addClass('in');
	    } else {
	        clearTimeout(timeout);
	    }
	    if (e.target === dropZone[0]) {
	        dropZone.addClass('success');
	    } else {
	        dropZone.removeClass('success');
	    }
	    window.dropZoneTimeout = setTimeout(function () {
	        window.dropZoneTimeout = null;
	        dropZone.removeClass('in hover');
	    }, 100);
	});
//
//	$('input[id=fileupload]').change(function() {
//		$('#filename').val(basename($(this).val()));
//	});
//	
	
	$('#packages').submit(function() {
		var packages = [];
		$.each($('.app.btn-primary'), function(index, element) {
			packages.push($(element).attr('packageName'));
		});
		if (packages.length == 0) {
			$('#selected').text('Please select at least one app for backup.');
			return false;
		}
		$('#submit').attr('value', JSON.stringify(packages));
		return true;
	});
	
	$('#select-all').click(function() {
		$('.app').addClass('btn-primary');
		$('#selected').text($('.app').length + ' apps selected for backup.');
		return false;
	})

	$('#deselect-all').click(function() {
		$('.app').removeClass('btn-primary');
		$('#selected').text('0 apps selected for backup.');
		return false;
	})
	
	function refreshApps() {
		$('#apps').empty();
		$.get('/api/package', function(data) {
			$.get('/views/app.jade', function(appTemplate) {
				var row;
				data.apps.sort(function(a, b) {
				    return a.label.toLowerCase().localeCompare(b.label.toLowerCase());
				});
				$.each(data.apps, function(index, app) {
					if (app.system)
						return;
					if (app.ignore)
						return;
					if (row == null || row[0].children.length == 4) {
						if (row != null) {
							$('#apps').append(row);
						}
						row = $('<div class="row"></div>')
					}
					app.icon = '/api/package/' + app.packageName + '/icon.png';
					
					jade.render(appTemplate, {
						app: app
					}, function(err, data) {
						if (err) {
							console.log(err);
							return;
						}

						row.append($(data));
					});
				});
				if (row != null) {
					$('#apps').append(row);
				}

				var selectedApps = 0;
				
				$('.app').click(function(event) {
					var element = event.currentTarget;
					if ($(element).hasClass('btn-primary')) {
						$(element).removeClass('btn-primary');
						selectedApps--;
					}
					else {
						$(element).addClass('btn-primary');
						selectedApps++;
					}
					
					$('#selected').text(selectedApps + ' apps selected for backup.');
				});
			});
		});
	}
	refreshApps();
});
